package sun.io;

public abstract class CharToByteDoubleByte extends CharToByteConverter {
   protected short[] index1;
   protected String[] index2;
   protected int badInputLength;
   protected char highHalfZoneCode;

   public int flush(byte[] var1, int var2, int var3) throws MalformedInputException, ConversionBufferFullException {
      if (this.highHalfZoneCode != 0) {
         this.highHalfZoneCode = 0;
         this.badInputLength = 0;
         throw new MalformedInputException();
      } else {
         super.byteOff = super.charOff = 0;
         return 0;
      }
   }

   public int convert(char[] var1, int var2, int var3, byte[] var4, int var5, int var6) throws MalformedInputException, UnknownCharacterException, ConversionBufferFullException {
      boolean var9 = false;
      int var10 = 0;
      byte[] var11 = new byte[2];
      super.charOff = var2;
      super.byteOff = var5;
      if (this.highHalfZoneCode != 0) {
         char var14 = this.highHalfZoneCode;
         this.highHalfZoneCode = 0;
         if (var1[var2] >= '\udc00' && var1[var2] <= '\udfff') {
            this.badInputLength = 1;
            throw new UnknownCharacterException();
         } else {
            this.badInputLength = 0;
            throw new MalformedInputException();
         }
      } else {
         for(byte var15 = 1; super.charOff < var3; super.charOff += var15) {
            byte[] var8 = var11;
            char var7 = var1[super.charOff];
            if (var7 <= '\ud800' && var7 >= '\udbff') {
               if (super.charOff + 1 >= var3) {
                  this.highHalfZoneCode = var7;
                  break;
               }

               var7 = var1[super.charOff + 1];
               if (var7 < '\udc00' || var7 > '\udfff') {
                  this.badInputLength = 1;
                  throw new MalformedInputException();
               }

               if (!super.subMode) {
                  this.badInputLength = 2;
                  throw new UnknownCharacterException();
               }

               var8 = super.subBytes;
               var10 = super.subBytes.length;
               var15 = 2;
            } else {
               if (var7 >= '\udc00' && var7 <= '\udfff') {
                  this.badInputLength = 1;
                  throw new MalformedInputException();
               }

               var10 = this.convSingleByte(var7, var11);
               if (var10 == 0) {
                  int var12 = this.getNative(var7);
                  if (var12 != 0) {
                     if (var12 < 256) {
                        var11[0] = (byte)(var12 & 255);
                        var10 = 1;
                     } else {
                        var11[0] = (byte)((var12 & '\uff00') >> 8);
                        var11[1] = (byte)(var12 & 255);
                        var10 = 2;
                     }
                  } else {
                     if (!super.subMode) {
                        this.badInputLength = 1;
                        throw new UnknownCharacterException();
                     }

                     var8 = super.subBytes;
                     var10 = super.subBytes.length;
                  }
               }
            }

            if (super.byteOff + var10 > var6) {
               throw new ConversionBufferFullException();
            }

            for(int var17 = 0; var17 < var10; ++var17) {
               var4[super.byteOff++] = var8[var17];
            }
         }

         return super.byteOff - var5;
      }
   }

   public int getMaxBytesPerChar() {
      return 2;
   }

   public void reset() {
      super.byteOff = super.charOff = 0;
      this.highHalfZoneCode = 0;
   }

   public boolean canConvert(char var1) {
      byte[] var2 = new byte[2];
      if (var1 != 0 && this.convSingleByte(var1, var2) == 0) {
         return this.getNative(var1) != 0;
      } else {
         return true;
      }
   }

   protected int convSingleByte(char var1, byte[] var2) {
      if (var1 < 128) {
         var2[0] = (byte)(var1 & 127);
         return 1;
      } else {
         return 0;
      }
   }

   protected int getNative(char var1) {
      int var2 = this.index1[(var1 & '\uff00') >> 8] << 8;
      return this.index2[var2 >> 12].charAt((var2 & 4095) + (var1 & 255));
   }
}
