package sun.io;

public class CharToByteEUC_JP extends CharToByteJIS0208 {
   CharToByteJIS0201 cbJIS0201 = new CharToByteJIS0201();
   CharToByteJIS0212 cbJIS0212 = new CharToByteJIS0212();

   public String getCharacterEncoding() {
      return "EUC_JP";
   }

   protected int convSingleByte(char var1, byte[] var2) {
      if (var1 == 0) {
         var2[0] = 0;
         return 1;
      } else {
         byte var3;
         if ((var3 = this.cbJIS0201.getNative(var1)) == 0) {
            return 0;
         } else if (var3 > 0 && var3 < 128) {
            var2[0] = var3;
            return 1;
         } else {
            var2[0] = -114;
            var2[1] = var3;
            return 2;
         }
      }
   }

   protected int getNative(char var1) {
      int var2 = CharToByteJIS0208.index1[(var1 & '\uff00') >> 8] << 8;
      int var3 = super.index2[var2 >> 12].charAt((var2 & 4095) + (var1 & 255));
      if (var3 != 0) {
         return var3 + '肀';
      } else {
         var3 = this.cbJIS0212.getNative(var1);
         return var3 == 0 ? var3 : var3 + 9404544;
      }
   }

   public int convert(char[] var1, int var2, int var3, byte[] var4, int var5, int var6) throws MalformedInputException, UnknownCharacterException, ConversionBufferFullException {
      boolean var9 = false;
      int var10 = 0;
      byte[] var11 = new byte[4];
      super.charOff = var2;
      super.byteOff = var5;
      if (super.highHalfZoneCode != 0) {
         char var14 = super.highHalfZoneCode;
         super.highHalfZoneCode = 0;
         if (var1[var2] >= '\udc00' && var1[var2] <= '\udfff') {
            super.badInputLength = 1;
            throw new UnknownCharacterException();
         } else {
            super.badInputLength = 0;
            throw new MalformedInputException();
         }
      } else {
         for(byte var15 = 1; super.charOff < var3; super.charOff += var15) {
            byte[] var8 = var11;
            char var7 = var1[super.charOff];
            if (var7 <= '\ud800' && var7 >= '\udbff') {
               if (super.charOff + 1 >= var3) {
                  super.highHalfZoneCode = var7;
                  break;
               }

               var7 = var1[super.charOff + 1];
               if (var7 < '\udc00' || var7 > '\udfff') {
                  super.badInputLength = 1;
                  throw new MalformedInputException();
               }

               if (!super.subMode) {
                  super.badInputLength = 2;
                  throw new UnknownCharacterException();
               }

               var8 = super.subBytes;
               var10 = super.subBytes.length;
               var15 = 2;
            } else {
               if (var7 >= '\udc00' && var7 <= '\udfff') {
                  super.badInputLength = 1;
                  throw new MalformedInputException();
               }

               var10 = this.convSingleByte(var7, var11);
               if (var10 == 0) {
                  int var12 = this.getNative(var7);
                  if (var12 != 0) {
                     if ((var12 & 16711680) == 0) {
                        var11[0] = (byte)((var12 & '\uff00') >> 8);
                        var11[1] = (byte)(var12 & 255);
                        var10 = 2;
                     } else {
                        var11[0] = -113;
                        var11[1] = (byte)((var12 & '\uff00') >> 8);
                        var11[2] = (byte)(var12 & 255);
                        var10 = 3;
                     }
                  } else {
                     if (!super.subMode) {
                        super.badInputLength = 1;
                        throw new UnknownCharacterException();
                     }

                     var8 = super.subBytes;
                     var10 = super.subBytes.length;
                  }
               }
            }

            if (super.byteOff + var10 > var6) {
               throw new ConversionBufferFullException();
            }

            for(int var17 = 0; var17 < var10; ++var17) {
               var4[super.byteOff++] = var8[var17];
            }
         }

         return super.byteOff - var5;
      }
   }

   public int getMaxBytesPerChar() {
      return 3;
   }
}
